## clonezilla-live-src-20141215-vivid-i386.ubuntu.tar.gz

=== CMakeLists.txt ===
# Copyright © 2012 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>,
#              Alan Griffiths <alan@octopull.co.uk>

set(CMAKE_GCOV gcov)

project(Mir)

cmake_minimum_required(VERSION 2.8)

cmake_policy(SET CMP0015 NEW)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)

set(MIR_VERSION_MAJOR 0)
set(MIR_VERSION_MINOR 9) # This should change at least with every MIRSERVER_ABI
set(MIR_VERSION_PATCH 0)

set(MIR_VERSION ${MIR_VERSION_MAJOR}.${MIR_VERSION_MINOR}.${MIR_VERSION_PATCH})

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
execute_process(
  COMMAND ${CMAKE_CXX_COMPILER} -dumpmachine
  OUTPUT_VARIABLE TARGET_ARCH
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

option(use_debflags "Use build flags from dpkg-buildflags." OFF)
if(use_debflags)
  include (cmake/Debian.cmake)
endif()
include (cmake/EnableCoverageReport.cmake)
include (cmake/MirCommon.cmake)
include (cmake/PrePush.cmake)
include (GNUInstallDirs)

set(build_types "None;Debug;Release;RelWithDebInfo;MinSizeRel;Coverage;AddressSanitizer")
# Change informational string for CMAKE_BUILD_TYPE
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "${build_types}" FORCE)
# Enable cmake-gui to display a drop down list for CMAKE_BUILD_TYPE
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "${build_types}")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread -g -Werror -Wall -pedantic -Wextra -fPIC")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -g -std=c++0x -Werror -Wall -fno-strict-aliasing -pedantic -Wnon-virtual-dtor -Wextra -fPIC")

if ("${CMAKE_CXX_COMPILER}" MATCHES "clang")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-return-type-c-linkage -Wno-mismatched-tags")
endif()

# Link time optimization allows leaner, cleaner libraries
message(STATUS "CMAKE_C_COMPILER: " ${CMAKE_C_COMPILER})

option(MIR_LINK_TIME_OPTIMIZATION "Enables the linker to optimize binaries." OFF)
if(MIR_LINK_TIME_OPTIMIZATION)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -flto")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flto")
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
if(cmake_build_type_lower MATCHES "coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ftest-coverage -fprofile-arcs")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs")
endif()

if(cmake_build_type_lower MATCHES "addresssanitizer")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fsanitize=address")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fsanitize=address")
else()
  # AddressSanitizer builds fail if we disallow undefined symbols
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--no-undefined")
endif()

# Define LOG_NDEBUG=1 to ensure Android ALOGV calls are not compiled in to
# consume CPU time...
add_definitions(-DLOG_NDEBUG=1)

enable_testing()

include_directories(include/common src/include/common)

# Check for boost
find_package(Boost 1.48.0 COMPONENTS date_time system program_options iostreams filesystem REQUIRED)
include_directories (
  ${Boost_INCLUDE_DIRS}
)

option(
  MIR_DISABLE_EPOLL_REACTOR
  "Disable boost::asio's epoll implementation and switch to a select-based reactor to account for ancient kernels on ppa builders."
  OFF
)
if(MIR_DISABLE_EPOLL_REACTOR)
add_definitions(
  -DBOOST_ASIO_DISABLE_EPOLL -DBOOST_ASIO_DISABLE_KQUEUE -DBOOST_ASIO_DISABLE_DEV_POLL
)
endif(MIR_DISABLE_EPOLL_REACTOR)

add_definitions(-DMESA_EGL_NO_X11_HEADERS)

# Default to mesa backend, but build all of them
set(
  MIR_PLATFORM
  mesa;android
  CACHE
  STRING
  "a list of graphics backends to build (options are 'mesa' or 'android')"
)

list(GET MIR_PLATFORM 0 MIR_TEST_PLATFORM)

foreach(platform IN LISTS MIR_PLATFORM)
  if (platform STREQUAL "mesa")
    set(MIR_BUILD_PLATFORM_MESA TRUE)
  endif()
  if (platform STREQUAL "android")
     set(MIR_BUILD_PLATFORM_ANDROID TRUE)
  endif()
endforeach(platform)

find_package(EGL REQUIRED)
find_package(GLESv2 REQUIRED)
find_package(GLM REQUIRED)
find_package(Protobuf REQUIRED )
find_package(GLog REQUIRED)
find_package(GFlags REQUIRED)
find_package(XKBCOMMON REQUIRED)
find_package(LTTngUST REQUIRED)
pkg_check_modules(UDEV REQUIRED libudev)
pkg_check_modules(GLIB REQUIRED glib-2.0)

include_directories (${GLESv2_INCLUDE_DIRS})
include_directories (${EGL_INCLUDE_DIRS})
include_directories (${GLM_INCLUDE_DIRS})

if (MIR_BUILD_PLATFORM_ANDROID)
  find_package(AndroidProperties REQUIRED)
  find_package(LibHardware REQUIRED)
endif()

if (MIR_BUILD_PLATFORM_MESA)
  find_package( PkgConfig )
  pkg_check_modules( GBM REQUIRED gbm>=9.0.0)
  pkg_check_modules( DRM REQUIRED libdrm )
endif()

set(MIR_ANDROID_INCLUDE_DIRECTORIES) # to be filled by android-input
set(MIR_ANDROID_INPUT_COMPILE_FLAGS) # to be filled by android-input
set(MIR_XCURSOR_INCLUDE_DIRECTORIES)
set(MIR_3RD_PARTY_INCLUDE_DIRECTORIES)
add_subdirectory(3rd_party/)

set(MIR_TRACEPOINT_LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/mir/tools)

set(MIR_GENERATED_INCLUDE_DIRECTORIES)
macro(uses_android_input _target_name)
  set_property(TARGET ${_target_name} APPEND_STRING PROPERTY COMPILE_FLAGS "${MIR_ANDROID_INPUT_COMPILE_FLAGS}")
endmacro()
add_subdirectory(src/)
include_directories(${MIR_GENERATED_INCLUDE_DIRECTORIES})

option(MIR_ENABLE_TESTS "Build tests" ON)

add_subdirectory(benchmarks/)
add_subdirectory(tools/)
add_subdirectory(examples/)
add_subdirectory(playground/)
add_subdirectory(guides/)
add_subdirectory(cmake/)

if (MIR_ENABLE_TESTS)
  find_package(Gtest REQUIRED)
  include_directories(${GMOCK_INCLUDE_DIR} ${GTEST_INCLUDE_DIR})
  add_subdirectory(tests/)

  # There's no nice way to format this. Thanks CMake.
  add_test(LGPL-required
    /bin/sh -c "! grep -rl 'GNU General' ${PROJECT_SOURCE_DIR}/src/client ${PROJECT_SOURCE_DIR}/include/client ${PROJECT_SOURCE_DIR}/src/common ${PROJECT_SOURCE_DIR}/include/common ${PROJECT_SOURCE_DIR}/src/include/common ${PROJECT_SOURCE_DIR}/src/platform ${PROJECT_SOURCE_DIR}/include/platform ${PROJECT_SOURCE_DIR}/src/include/platform"
  )
  add_test(GPL-required
    /bin/sh -c "! grep -rl 'GNU Lesser' ${PROJECT_SOURCE_DIR}/src/server ${PROJECT_SOURCE_DIR}/include/server ${PROJECT_SOURCE_DIR}/src/include/server ${PROJECT_SOURCE_DIR}/tests ${PROJECT_SOURCE_DIR}/examples"
  )
  
  add_test(NAME server-ABI-unchanged
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    COMMAND sha1sum -c server-ABI-sha1sums
  )
  
  add_test(NAME client-ABI-unchanged
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    COMMAND sha1sum -c client-ABI-sha1sums
  )

  add_test(NAME common-ABI-unchanged
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    COMMAND sha1sum -c common-ABI-sha1sums
  )

  add_test(NAME platform-ABI-unchanged
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    COMMAND sha1sum -c platform-ABI-sha1sums
  )
endif ()

enable_coverage_report(mirserver)
include (cmake/Doxygen.cmake)
include (cmake/ABICheck.cmake)

=== examples/CMakeLists.txt ===

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -Wall -fno-strict-aliasing -Wextra")

add_library(eglapp STATIC
  eglapp.c
)

add_library(exampleserverconfig STATIC
  example_display_configuration_policy.cpp
  example_input_event_filter.cpp
)

target_link_libraries(eglapp
  mirclient
  ${EGL_LIBRARIES}
  ${GLESv2_LIBRARIES}
)
add_executable(mir_demo_client_eglflash
  eglflash.c
)
target_link_libraries(mir_demo_client_eglflash
  eglapp
)
add_executable(mir_demo_client_egltriangle
  egltriangle.c
)
target_link_libraries(mir_demo_client_egltriangle
  eglapp
)
add_executable(mir_demo_client_eglcounter
  eglcounter.cpp
)
target_link_libraries(mir_demo_client_eglcounter
  eglapp
)
add_executable(mir_demo_client_eglplasma
  eglplasma.c
)
target_link_libraries(mir_demo_client_eglplasma
  eglapp
)
add_executable(mir_demo_client_cursors
  cursors_demo_client.c
)
target_link_libraries(mir_demo_client_cursors
  eglapp
)

add_executable(mir_demo_client_basic
  basic.c
)

target_link_libraries(mir_demo_client_basic
  mirclient

  ${Boost_LIBRARIES}
  ${PROTOBUF_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
)

add_executable(mir_test_client_release_at_exit release_at_exit.c)
target_link_libraries(mir_test_client_release_at_exit mirclient)

add_executable(mir_demo_client_multiwin multiwin.c)
target_link_libraries(mir_demo_client_multiwin mirclient)

add_executable(mir_demo_client_fingerpaint fingerpaint.c)
target_link_libraries(mir_demo_client_fingerpaint mirclient)

add_executable(mir_demo_client_progressbar progressbar.c)
target_link_libraries(mir_demo_client_progressbar mirclient)

add_executable(mir_demo_client_display_config demo_client_display_config.c)
target_link_libraries(mir_demo_client_display_config eglapp)

add_executable(mir_demo_client_flicker
  flicker.c
)

target_link_libraries(mir_demo_client_flicker
  mirclient

  ${Boost_LIBRARIES}
  ${PROTOBUF_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
)

add_executable(mir_demo_client_scroll
  scroll.cpp
)

target_link_libraries(mir_demo_client_scroll
  mirdraw
  mirclient

  ${Boost_LIBRARIES}
  ${PROTOBUF_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
  ${EGL_LIBRARIES}
  ${GLESv2_LIBRARIES}

)

add_executable(mir_demo_client_prompt_session prompt_session.c)
target_link_libraries(mir_demo_client_prompt_session mirclient)

add_library(mirdraw STATIC graphics_utils.cpp)
target_link_libraries(mirdraw ${GLESv2_LIBRARIES})

include_directories(
  ${PROJECT_SOURCE_DIR}/include/server
  ${PROJECT_SOURCE_DIR}/include/client
  ${PROJECT_SOURCE_DIR}/include/platform
  ${GLESv2_INCLUDE_DIRS}
)

add_executable(mir_demo_standalone_render_to_fb
    render_to_fb.cpp
)

target_link_libraries(mir_demo_standalone_render_to_fb
    mirserver
    mirdraw
    ${Boost_LIBRARIES}
)

add_executable(mir_demo_standalone_input_filter
  demo_input_filter.cpp
)

target_link_libraries(mir_demo_standalone_input_filter
  mirserver
  exampleserverconfig
)

set (INSTALL_DEMOS
  mir_demo_client_basic
  mir_demo_client_flicker
  mir_demo_client_scroll
  mir_demo_client_eglflash
  mir_demo_client_egltriangle
  mir_demo_client_eglplasma
  mir_demo_client_eglcounter
  mir_demo_client_fingerpaint
  mir_demo_client_multiwin
  mir_demo_client_display_config
  mir_demo_client_progressbar
  mir_demo_client_prompt_session
  mir_demo_standalone_input_filter
  mir_demo_standalone_render_to_fb
)

install(TARGETS ${INSTALL_DEMOS} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

add_executable(mir_demo_server_basic
  basic_server.cpp
  glog_logger.cpp
)

target_link_libraries(mir_demo_server_basic
  mirserver
  exampleserverconfig
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
  ${Boost_LIBRARIES}
)

install(TARGETS mir_demo_server_basic
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

add_executable(mir_demo_server_minimal minimal_server.cpp)
target_link_libraries(mir_demo_server_minimal mirserver)
install(TARGETS mir_demo_server_minimal
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

add_executable(mir_demo_standalone_render_overlays
    render_overlays.cpp
)

target_link_libraries(mir_demo_standalone_render_overlays
    mirserver
    mirtestdraw
    mircommon
)

install(TARGETS mir_demo_standalone_render_overlays
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

add_subdirectory(testdraw/)

=== playground/CMakeLists.txt ===

include_directories(
  ${PROJECT_SOURCE_DIR}/src/include/server
  ${PROJECT_SOURCE_DIR}/src/include/platform
  ${PROJECT_SOURCE_DIR}/include/client
  ${PROJECT_SOURCE_DIR}/include/server
  ${PROJECT_SOURCE_DIR}/include/platform
  ${PROJECT_SOURCE_DIR}/examples/
)

add_library(playgroundserverconfig STATIC
    server_configuration.cpp
)

set(RENDER_SURFACES_SOURCES
    render_surfaces.cpp
    buffer_render_target.cpp
    image_renderer.cpp
)
add_executable(mir_demo_standalone_render_surfaces ${RENDER_SURFACES_SOURCES})
target_link_libraries(mir_demo_standalone_render_surfaces
    mirserver
    playgroundserverconfig
    exampleserverconfig
    ${Boost_LIBRARIES}
)

install(TARGETS mir_demo_standalone_render_surfaces RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

add_subdirectory(demo-shell/)
add_subdirectory(demo-inprocess-surface-client/)

=== src/CMakeLists.txt ===
set(MIR_GENERATED_INCLUDE_DIRECTORIES)
add_subdirectory(common/)
add_subdirectory(protobuf/)
include_directories(${MIR_GENERATED_INCLUDE_DIRECTORIES})

add_subdirectory(platform/)
add_subdirectory(server/)
add_subdirectory(client/)
add_subdirectory(utils/)

set(
  MIR_GENERATED_INCLUDE_DIRECTORIES
  ${MIR_GENERATED_INCLUDE_DIRECTORIES}
  PARENT_SCOPE)

set(MIR_SERVER_OBJECTS ${MIR_SERVER_OBJECTS} PARENT_SCOPE)
set(MIR_SERVER_REFERENCES ${MIR_SERVER_REFERENCES} PARENT_SCOPE)
set(MIR_PLATFORM_OBJECTS ${MIR_PLATFORM_OBJECTS} PARENT_SCOPE)
set(MIR_PLATFORM_REFERENCES ${MIR_PLATFORM_REFERENCES} PARENT_SCOPE)
set(MIR_COMMON_OBJECTS ${MIR_COMMON_OBJECTS} PARENT_SCOPE)
set(MIR_COMMON_REFERENCES ${MIR_COMMON_REFERENCES} PARENT_SCOPE)

=== tests/CMakeLists.txt ===
pkg_check_modules(UMOCKDEV REQUIRED umockdev-1.0>=0.6)
if (NOT UMOCKDEV_FOUND)
  message(FATAL_ERROR "Umockdev not found, cannot build without disabling tests (via MIR_ENABLE_TESTS).")
endif()

include_directories(${MIR_3RD_PARTY_INCLUDE_DIRECTORIES})
include_directories(${MIR_ANDROID_INCLUDE_DIRECTORIES})

include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-Wnull-dereference HAS_W_NULL_DEREFERENCE)
check_cxx_compiler_flag(-Woverloaded-virtual HAS_W_OVERLOADED_VIRTUAL)
check_cxx_compiler_flag(-Winconsistent-missing-override HAS_W_INCONSISTENT_MISSING_OVERRIDE)

if (HAS_W_NULL_DEREFERENCE)
  # Avoid clang complaints about poor quality gmock/gtest headers
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=null-dereference")
endif()
if (HAS_W_OVERLOADED_VIRTUAL)
  # Avoid clang complaints about poor quality gmock/gtest headers
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=overloaded-virtual")
endif()
if (HAS_W_INCONSISTENT_MISSING_OVERRIDE)
  # MOCK_METHOD()s cannot be marked as override; we cannot consistently mark overrides
  # in the tests.
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-inconsistent-missing-override")
endif()

if (MIR_TEST_PLATFORM STREQUAL "android")
  #avoid complaints about poor quality android headers
  include_directories(SYSTEM ${LIBHARDWARE_INCLUDE_DIRS})
  add_definitions(-DANDROID)
endif()

include_directories(
  include
  ${PROJECT_SOURCE_DIR}/include/platform
  ${PROJECT_SOURCE_DIR}/include/server
  ${PROJECT_SOURCE_DIR}/include/client
)

option(MIR_BUILD_ACCEPTANCE_TESTS "Build acceptance tests" ON)
option(MIR_BUILD_INTEGRATION_TESTS "Build integration tests" ON)
option(MIR_BUILD_PERFORMANCE_TESTS "Build performance tests" ON)
option(MIR_BUILD_UNIT_TESTS "Build unit tests" ON)

if (MIR_BUILD_ACCEPTANCE_TESTS)
  add_subdirectory(acceptance-tests/)
endif (MIR_BUILD_ACCEPTANCE_TESTS)

if (MIR_BUILD_INTEGRATION_TESTS)
  add_subdirectory(integration-tests/)
endif (MIR_BUILD_INTEGRATION_TESTS)

if (MIR_BUILD_PERFORMANCE_TESTS)
    add_subdirectory(performance-tests/)
endif(MIR_BUILD_PERFORMANCE_TESTS)

if (MIR_BUILD_UNIT_TESTS)
  add_subdirectory(unit-tests/)
endif (MIR_BUILD_UNIT_TESTS)

add_subdirectory(mir_test/)
add_subdirectory(mir_test_framework/)
add_subdirectory(mir_test_doubles/)
add_subdirectory(client-language/)
add_subdirectory(mir-stress/)

mir_add_memcheck_test()

=== benchmarks/android-input/CMakeLists.txt ===
project(android-input-perf)

set(SOURCES
 input_reader_perf.cpp
 )

include_directories(
  ${Mir_SOURCE_DIR}/tests/include
  ${Mir_SOURCE_DIR}/include/platform
  ${MIR_ANDROID_INCLUDE_DIRECTORIES}
  ${MIR_3RD_PARTY_INCLUDE_DIRECTORIES}
)

add_executable(input-reader-perf ${SOURCES})

target_link_libraries(
  input-reader-perf

  android-input
  mir-test-doubles
  mirserver
 )

uses_android_input(input-reader-perf)

=== benchmarks/frame-uniformity/CMakeLists.txt ===
include_directories(
  ${PROJECT_SOURCE_DIR}/include/common
  ${PROJECT_SOURCE_DIR}/include/platform
  ${PROJECT_SOURCE_DIR}/include/server
  ${PROJECT_SOURCE_DIR}/include/client
  ${PROJECT_SOURCE_DIR}/tests/include/

  ${PROJECT_SOURCE_DIR}/src/include/platform
  ${PROJECT_SOURCE_DIR}
  ${MIR_ANDROID_INCLUDE_DIRECTORIES}
  ${MIR_3RD_PARTY_INCLUDE_DIRECTORIES}
)

add_executable(frame_uniformity_test_client
  touch_measuring_client.cpp
  touch_producing_server.cpp
  frame_uniformity_test.cpp
  vsync_simulating_graphics_platform.cpp
  touch_samples.cpp
  main.cpp
)

target_link_libraries(frame_uniformity_test_client
  mirserver
  mirclient
  
  mir-test
  mir-test-framework
  mir-test-doubles
  mir-test-doubles-platform

  # Why does this have to come after mir-test-framework here but not in tests/acceptance-tests/
  # /CMakeLists.txt? ~racarr
  mirplatform

  3rd_party
  ${PROTOBUF_LIBRARIES}
  ${Boost_LIBRARIES}
  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARY}
  ${GMOCK_MAIN_LIBRARY}
  ${CMAKE_THREAD_LIBS_INIT} # Link in pthread.
)

uses_android_input(frame_uniformity_test_client)

=== playground/demo-inprocess-surface-client/CMakeLists.txt ===
add_executable(mir_demo_standalone_inprocess_egl
  demo_inprocess_surface_client.cpp
  inprocess_egl_client.cpp
  example_egl_helper.cpp
)

target_link_libraries(mir_demo_standalone_inprocess_egl
  mirserver
  mirdraw
  playgroundserverconfig
  exampleserverconfig
)
# TODO Install this demo?

=== playground/demo-shell/CMakeLists.txt ===
add_library(demo-shell STATIC
  demo_compositor.cpp
  demo_renderer.cpp
  fullscreen_placement_strategy.cpp
  window_manager.cpp
)

add_executable(mir_demo_server_shell
  demo_shell.cpp
)

target_link_libraries(mir_demo_server_shell
  demo-shell
  mirserver
  playgroundserverconfig
  exampleserverconfig
)

install(TARGETS mir_demo_server_shell RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== src/client/CMakeLists.txt ===
set(MIRCLIENT_ABI 8)
set(CLIENT_DRIVER client${MIRCLIENT_ABI}driver)
set(MIR_CLIENT_DRIVER mir${CLIENT_DRIVER})
set(MIR_CLIENT_DRIVER_BINARY lib${MIR_CLIENT_DRIVER}.so
    CACHE STRING "File name of Mir client drivers")
add_definitions(-DMIR_CLIENT_DRIVER_BINARY="${MIR_CLIENT_DRIVER_BINARY}")

set(PREFIX "${CMAKE_INSTALL_PREFIX}")
set(EXEC_PREFIX "${CMAKE_INSTALL_PREFIX}")
set(LIBDIR "${CMAKE_INSTALL_FULL_LIBDIR}")
set(INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include")

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/mirclient.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/mirclient.pc
  @ONLY
)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/mirclient-debug-extension.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/mirclient-debug-extension.pc
  @ONLY
)

include_directories(
  ${PROTOBUF_INCLUDE_DIRS}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${PROJECT_SOURCE_DIR}/include/client
  ${PROJECT_SOURCE_DIR}/src/include/client
  ${DRM_INCLUDE_DIRS}
)

add_subdirectory(rpc/)
add_subdirectory(lttng/)

add_library(mirclient_platformimpl OBJECT
  aging_buffer.cpp
)

if(MIR_BUILD_PLATFORM_ANDROID)
add_subdirectory(android/)
endif()

if(MIR_BUILD_PLATFORM_MESA)
add_subdirectory(mesa/)
endif()

add_library(mirclientobjects OBJECT

  client_buffer_depository.cpp
  display_configuration.cpp
  error_connections.cpp
  mir_connection.cpp
  mir_connection_api.cpp
  mir_wait_handle.cpp
  mir_wait_api.cpp
  mir_surface.cpp
  mir_surface_api.cpp
  logging/rpc_report.cpp
  logging/input_receiver_report.cpp
  logging/perf_report.cpp
  default_connection_configuration.cpp
  surface_map.cpp
  lifecycle_control.cpp
  private.cpp
  mir_screencast.cpp
  mir_screencast_api.cpp
  mir_cursor_api.cpp
  mir_prompt_session.cpp
  mir_prompt_session_api.cpp
  mir_event_distributor.cpp
  periodic_perf_report.cpp
)

add_library(
  mirclient SHARED

  $<TARGET_OBJECTS:mirclientobjects>
)

set(symbol_map ${CMAKE_CURRENT_SOURCE_DIR}/symbols.map)

set_target_properties(
  mirclient

  PROPERTIES
  SOVERSION ${MIRCLIENT_ABI}
  LINK_FLAGS "-Wl,--exclude-libs=ALL -Wl,--version-script,${symbol_map}"
)

target_link_libraries(mirclient
  mirclientrpc
  mirclientlttngstatic
  mircommon
  mirprotobuf

  ${Boost_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
  ${XKBCOMMON_LIBRARIES}
)

install(
  TARGETS mirclient
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(
  DIRECTORY ${CMAKE_SOURCE_DIR}/include/client/mir_toolkit
  DESTINATION "include/mirclient"
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/mirclient.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

# TODO: Extension apparatus so that mirclient-debug-extension can be a MODULE and not
#       duplicate (almost) the entirity of mirclient

set(MIRCLIENT_DEBUG_EXTENSION_ABI 1)

add_library(
  mirclient-debug-extension SHARED

  mir_debug_api.cpp
  $<TARGET_OBJECTS:mirclientobjects>
)

target_link_libraries(
  mirclient-debug-extension

  mirclient
)

set(debug_symbol_map ${CMAKE_CURRENT_SOURCE_DIR}/symbols-debug.map)

set_target_properties(
  mirclient-debug-extension

  PROPERTIES
  SOVERSION ${MIRCLIENT_DEBUG_EXTENSION_ABI}
  LINK_FLAGS "-Wl,--version-script,${debug_symbol_map}"
)

install(
  DIRECTORY ${CMAKE_SOURCE_DIR}/include/client/mir_toolkit/debug
  DESTINATION "include/mirclient/mir_toolkit/debug"
)

install(
  TARGETS mirclient-debug-extension
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/mirclient-debug-extension.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== src/common/CMakeLists.txt ===
set(MIR_GENERATED_INCLUDE_DIRECTORIES)
set(MIR_COMMON_SOURCES)
set(MIR_COMMON_REFERENCES)

if (MIR_BUILD_PLATFORM_ANDROID)
  add_subdirectory(graphics/android)
endif()

add_subdirectory(fd)
add_subdirectory(geometry)
add_subdirectory(input)
add_subdirectory(logging)
add_subdirectory(report/lttng)
add_subdirectory(env)
add_subdirectory(sharedlibrary)
add_subdirectory(thread)
add_subdirectory(time)
list(APPEND MIR_COMMON_SOURCES $<TARGET_OBJECTS:mirtime>)

set(PREFIX "${CMAKE_INSTALL_PREFIX}")
set(EXEC_PREFIX "${CMAKE_INSTALL_PREFIX}")
set(LIBDIR "${CMAKE_INSTALL_FULL_LIBDIR}")
set(INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include/mircommon")

set(
  MIR_GENERATED_INCLUDE_DIRECTORIES
  ${MIR_GENERATED_INCLUDE_DIRECTORIES}
  PARENT_SCOPE)


MESSAGE( STATUS "MIR_COMMON_SOURCES. . . : ${MIR_COMMON_SOURCES}" )
MESSAGE( STATUS "MIR_COMMON_REFERENCES . : ${MIR_COMMON_REFERENCES}" )

add_library(mircommon
  SHARED
  ${MIR_COMMON_SOURCES}
)

target_link_libraries(mircommon
  ${MIR_COMMON_REFERENCES}
)

# TODO we need a place to manage ABI and related versioning but use this as placeholder
set(MIRCOMMON_ABI 3)
set(symbol_map ${CMAKE_CURRENT_SOURCE_DIR}/symbols.map)

set_target_properties(mircommon

  PROPERTIES
  SOVERSION ${MIRCOMMON_ABI}
  LINK_FLAGS "-Wl,--exclude-libs=ALL -Wl,--version-script,${symbol_map}"
)

install(TARGETS mircommon LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(
  DIRECTORY ${CMAKE_SOURCE_DIR}/include/common/mir ${CMAKE_SOURCE_DIR}/include/common/mir_toolkit
  DESTINATION "include/mircommon"
)

set(MIR_COMMON_OBJECTS ${MIR_COMMON_SOURCES} PARENT_SCOPE)
set(MIR_COMMON_REFERENCES ${MIR_COMMON_REFERENCES} PARENT_SCOPE)

=== src/platform/CMakeLists.txt ===
include_directories(
  ${PROJECT_SOURCE_DIR}/include/platform
  ${PROJECT_SOURCE_DIR}/src/include/platform
)

set(MIRPLATFORM_ABI 4)

set(PLATFORM_DRIVER platform${MIRPLATFORM_ABI}driver)
set(MIR_PLATFORM_DRIVER mir${PLATFORM_DRIVER})
set(MIR_PLATFORM_DRIVER_BINARY lib${MIR_PLATFORM_DRIVER}.so
    CACHE STRING "File name of Mir server platform drivers")
add_definitions(-DMIR_PLATFORM_DRIVER_BINARY="${MIR_PLATFORM_DRIVER_BINARY}")

set(symbol_map ${CMAKE_CURRENT_SOURCE_DIR}/symbols.map)

add_library(mirplatformobjects OBJECT
  shared_library_loader.cpp
)

set(MIR_PLATFORM_OBJECTS
  $<TARGET_OBJECTS:mirplatformobjects>
  $<TARGET_OBJECTS:mirplatformgraphicscommon>
  $<TARGET_OBJECTS:miroptions>
  $<TARGET_OBJECTS:mirfatal>
)

set(MIR_PLATFORM_REFERENCES
  ${EGL_LDFLAGS} ${EGL_LIBRARIES}
  ${GLESv2_LDFLAGS} ${GLESv2_LIBRARIES}
)

set(MIR_PLATFORM_OBJECTS ${MIR_PLATFORM_OBJECTS} PARENT_SCOPE)
set(MIR_PLATFORM_REFERENCES ${MIR_PLATFORM_REFERENCES} PARENT_SCOPE)

add_library(mirplatform SHARED
  ${MIR_PLATFORM_OBJECTS}
)

target_link_libraries(mirplatform
  mircommon
  ${MIR_PLATFORM_REFERENCES}
)

set_target_properties(mirplatform
  PROPERTIES
  SOVERSION ${MIRPLATFORM_ABI}
  LINK_FLAGS "-Wl,--exclude-libs=ALL -Wl,--version-script,${symbol_map}"
)


install(TARGETS mirplatform LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

add_subdirectory(graphics/)
add_subdirectory(options)
add_subdirectory(fatal)

set(INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include/mirplatform")
set(COMMON_INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include/mircommon")
set(LIBDIR "${CMAKE_INSTALL_FULL_LIBDIR}")

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/mirplatform.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/mirplatform.pc
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/mirplatform.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== changelog ===
glibc (2.19-13ubuntu3) vivid; urgency=medium

  * any/cvs-CVE-2014-7817.diff: Backport fix from trunk for wordexp,
    making it honour the WRDE_NOCMD flag in all cases (LP: #1396471)
  * Update to release/2.19/master, fixing arm64 frame bug in _start.

 -- Adam Conrad <adconrad@ubuntu.com>  Thu, 04 Dec 2014 16:56:41 -0700

glibc (2.19-13ubuntu2) vivid; urgency=medium

  * No, really, remove obsolete /etc/ld.so.conf.d/i686-linux-gnu.conf.

 -- Adam Conrad <adconrad@ubuntu.com>  Tue, 11 Nov 2014 20:35:28 -0700

glibc (2.19-13ubuntu1) vivid; urgency=medium

  * Merge with Debian unstable, pulling in upstream and package fixes.
  * Re-enable the testsuite that was disabled in Debian for the freeze.
  * Drop obsolete /etc/ld.so.conf.d/i686-linux-gnu.conf (LP: #1381656)
  * Update to release/2.19/master, and readjust patches to compensate:
    - localedata/unsubmitted-tst-setlocale3-ENV.diff: Superseded.
    - s390/cvs-s390-abi-reversal.diff: Superseded.
    - any/cvs-resolv-reuse-fd.diff: Superseded.
    - any/cvs-posix_spawn_file_actions_addopen.diff: Superseded.
    - any/cvs-setlocale-alloca.diff: Superseded.
    - any/cvs-CVE-2014-0475.diff: Superseded.
    - any/cvs-CVE-2014-5119.diff: Superseded.
    - any/cvs-CVE-2014-6040.diff: Superseded.
    - any/cvs-resolv-first-query-failure.diff: Rebased with upstream.
  * testsuite-checking: Ignore failures of the tst-dl-iter-static test,
    which are caused by the lddebug-scopes patch, while we work out a
    better solution upstream to the GDB versus linux-vdso.so.1 problem.
  * Pull in latest PPC fixes from ibm/2.19/master branch (LP: #1341569)

 -- Adam Conrad <adconrad@ubuntu.com>  Tue, 11 Nov 2014 18:48:22 -0700

glibc (2.19-13) unstable; urgency=medium

  [ Aurelien Jarno ]
  * kfreebsd/local-fbtl.diff: update to revision 5677 (from glibc-bsd).
    Workarounds a kfreebsd 9.0 to 10.1 ABI break. Closes: #740509.
  * patches/hppa/cvs-sigrtmin.diff: backport patch from upstream to change
    __SIGRTMIN to match other architectures. Closes: #766605.
  * patches/amd64/cvs-slow-sse42.diff: backport patch from upstream to fix
    a performance issue with strcmp and friends functions on some machines.
  * patches/any/cvs-regex-alloca.diff: new patch from upstream to fix a 
    segmentation fault in regex in case of heap allocation failure. Closes:
    #767225.
  * Don't fail to build in case of testsuite regressions, so that changes
    in the environment (e.g.: kernel) do not prevent security or stable 
    versions to be built. It will be re-enabled after the Jessie release.
  * debian/control.in/main: build-depends on debhelper (>= 9.20141010) to
    get Build-Profiles features. This fixes the following lintian warning:
    restriction-formula-with-debhelper-without-debhelper-version.

  [ Samuel Thibault ]
  * hurd-i386/cvs-libpthread.diff: Update to Sun Nov 2.
  * hurd-i386/libpthread_clean.diff: Refresh, most of it merged into
    cvs-libpthread.diff.
  * hurd-i386/cvs-libpthread-pthread_condattr_setclock.diff,
    cvs-libpthread_guardsize.diff, cvs-libpthread_std_thread.diff: Remove,
    merged into cvs-libpthread.diff.

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 06 Nov 2014 20:28:41 +0100

glibc (2.19-12) unstable; urgency=medium

  [ Samuel Thibault ]
  * patches/hurd-i386/tg-thread-cancel.diff: Update patch from upstream, fixes
    a rare deadlock.
  * patches/hurd-i386/local-libpthread-stacksize.diff: New patch to make
    libpthread stacks size default to 8MiB like on Linux, to avoid surprises
    with packages which assume the Linuxish default.
  * patches/hurd-i386/tg-poll_errors_fixes.diff: Update patch, fixes
    select returned value in case of errors. Closes: #764840.

  [ Petr Salinger ]
  * update testsuite-checking/expected-results-*-kfreebsd-gnu-*
    under 10.x kernels, provided by Steven Chamberlain. Closes: #762404.

  [ Aurelien Jarno ]
  * Remove mtrace(1) and pldd(1) manpages, provided by the manpages package
    starting with version 3.74.
  * debian/control.in/*: update the syntax of the Build-Profiles field and
    build depends on dpkg-dev (>= 1.17.14) to get the new feature. Closes:
    #764274.
  * Remove libc6-prof package as it's broken for years and there are better
    way to profile code nowadays. Closes: #760450.
  * patches/amd64/local-blacklist-on-TSX-Haswell.diff: new patch from 
    Henrique de Moraes Holschuh to disable TSX on processors which might get
    it disable through a microcode update. Closes: #762195.
  * Install French, German, Polish and Spanish version of validlocale(8)
    manpage. Add a Replaces: manpages-fr-extra (<= 20141008).
  * Update French manpages translations, by David Prévot. Closes: #715289.
  * Update German manpages translations, by Helge Kreutzmann. Closes: #717979.
  * kfreebsd/local-fbtl.diff: update to revision 5651 (from glibc-bsd).
    Workarounds a kfreebsd 9.0 to 10.1 ABI break. Closes: #740509.
  * patches/any/cvs-CVE-2014-6040.diff: new patch from upstream to fix crashes
    on invalid input in IBM gconv modules (CVE-2014-6040).
  * patches/any/cvs-check_pf-infinite-loop.diff: new patch from upstream to
    fix an infinite loop in infinite loop in check_pf.
  * patches/any/local-static-dlopen-search-path.diff: new patch to re-enable
    default search path for dlopen() in static libraries. Closes: #754813,
    #757941.

  [ Helmut Grohne ]
  * debian/patches/any/local-bootstrap-headers.diff: Update to handle
    stubs-$abi.h which is required for multilib bootstraps. Closes: #756473

 -- Aurelien Jarno <aurel32@debian.org>  Wed, 22 Oct 2014 20:01:11 +0200

glibc (2.19-11) unstable; urgency=medium

  [ Samuel Thibault ]
  * patches/hurd-i386/tg-thread-cancel.diff: Update patch against two other
    overzealous assertions.
  * patches/hurd-i386/submitted-bind_umask.diff: Split into cvs-bind_umask.diff
    and submitted-bind_umask2.diff as requested by upstream.
  * patches/hurd-i386/cvs-fork_ss_hang.diff: New patch which fixes some dash
    hangs.


=== debian/changelog ===
dpkg (1.17.21ubuntu2) vivid; urgency=medium

  * Cherry-pick from Debian (LP: #1394893)
    + Add Breaks on old man-db, fontconfig and readahead-fedora packages using
      awaiting triggers, as they produce trigger cycles. Closes: #768599
  * Modify the above to specify the version of fontconfig that included this
    change in Ubuntu, and to add ureadahead.

 -- Iain Lane <iain.lane@canonical.com>  Mon, 08 Dec 2014 12:09:15 +0000

dpkg (1.17.21ubuntu1) vivid; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Special-case arm{el,hf} ELF objects in Shlibs/Objdump.pm for multilib.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade
      when there are unqualified names stored in the dpkg trigger database.
    - Add logic to the postinst to `dpkg --add-architecture i386' on new
      installs on amd64, mimicking our previous behaviour with the conffile.
    - Apply a workaround from mvo to consider ^rc packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).
  * drop po/pot delta that was generated by MoM
  * run touch configure configure.ac build-aux/* to ensure that timestamps
    match and automake is not invoked again

 -- Michael Vogt <michael.vogt@ubuntu.com>  Wed, 29 Oct 2014 10:07:32 +0100

dpkg (1.17.21) unstable; urgency=low

  [ Guillem Jover ]
  * Get consistent git-style diff support, by adding (>= 2.7) to the dpkg-dev
    patch Depends, and a Breaks patch (<< 2.7) to libdpkg-perl.
  * Error out on obsolete Build-Profiles field syntax.
  * Document -g and -G options in dpkg-genchanges(1). Closes: #766568
  * Do not accept values bundled with long options in dpkg-parsechangelog.
    The parser was accepting things like «--count10», which is just broken.
    Instead allow only «--count=10» in addition to «--count 10».
  * Accept «-S value» in addition to «-Svalue» in dpkg-parsechangelog.
    Closes: #766559
  * Add support for new interest-await and activate-await trigger directives.
    And a new --await option to dpkg-trigger. This might allow possibly
    switching the default meaning after a transition period no shorter than
    two minor versions, so in 1.19.x or 1.20.x. Perhaps.
  * Do trigger cycle detection after dependency checks in dependtry <= 1,
    and before dependency cycle breaking in dependtry > 1. This makes sure
    to always catch trigger cycles, but still gives the opportunity to try
    to process triggers for packages that are not yet ready in the first
    dependtry, but which might be a bit later on, without wrongly detecting
    avoidable and bogus trigger cycles. Closes: #766557
  * Update features removal schedule:
    - The -u, --udeb dpkg-scanpackages options got removed, state that.
    - Remove the entry about obsolete fields, as these need to be preserved
      for backward compatibility, they are part of the external interface to
      be able to handle ancient binary packages.

  [ Updated programs translations ]
  * Catalan (Guillem Jover).
  * German (Sven Joachim). Closes: #766311
  * Simplified Chinese (Zhou Mo).

  [ Updated scripts translations ]
  * Catalan (Guillem Jover).

 -- Guillem Jover <guillem@debian.org>  Sat, 25 Oct 2014 02:21:43 +0200

dpkg (1.17.20) unstable; urgency=low

  [ Guillem Jover ]
  * Add a requeueing insertion protection for process_queue().
  * Make sure to always switch to the next dependtry after we have made no
    progress for a while. Regression stemming from non future proof changes
    introduced with the initial triggers implementation in dpkg 1.14.17
    combined with changes in dpkg 1.17.19. Closes: #766242, #766322
  * Make the initial dependtry be 1 instead of 0. This gets rid of an unused
    dependtry step, which got accidentally introduced when the perl dpkg was
    rewritten in C, ages ago.
  * Allow detached upstream signatures for upstream orig.tar files in the
    .dsc file. Suggested by Daniel Kahn Gillmor <dkg@fifthhorseman.net>.
    Closes: #759478
  * Inline alternative status description into translatable string in
    update-alternatives. Required-by: #766311
  * Reword description for installed status in dpkg(1) man page.

  [ Updated programs translations ]
  * German (Sven Joachim).
  * Simplified Chinese (Zhou Mo).
  * Vietnamese (Trần Ngọc Quân).

 -- Guillem Jover <guillem@debian.org>  Thu, 23 Oct 2014 00:43:05 +0200

dpkg (1.17.19) unstable; urgency=low

  [ Guillem Jover ]
  * Bump the Breaks on devscripts to 2.14.10 due to the new dpkg-architecture
    command-line parsing strictness introduced in 1.17.17. Closes: #764965
  * Create pidfiles even when start-stop-daemon is not asked to background
    the process itself. Although a bit of a dubious usage, because any error
    before executing the program will not be properly reported to the caller.
    Regression introduced in dpkg 1.17.14. Closes: #765110
  * Add new --remove-pidfile option to start-stop-daemon.
  * Mention --pid and --ppid in start-stop-daemon(8) man page DESCRIPTION.
  * Add invoke hooks for dpkg --add-architecture and --remove-architecture.
    Prompted by Helmut Grohne <helmut@subdivi.de>.
  * Reverse --verify-format logic to actually accept 'rpm' as valid.
    Closes: #765907
  * Fix trigger dependency checks and cycle detection.
    Regression introduced in dpkg 1.17.17.
    Closes: #765434, #765668, #765734, #765781, #765789, #765952
  * Rework dependency problem debug and notice output on trigger processing.

  [ Updated programs translations ]
  * Italian (Milo Casagrande): Closes: #765748


=== control ===
Source: glibc
Section: libs
Priority: required
Build-Depends: gettext, dpkg-dev (>= 1.17.14), xz-utils, file, quilt,
 autoconf, gawk, debhelper (>= 9.20141010), rdfind, symlinks, netbase,
 linux-libc-dev (>= 3.9) [linux-any],
 libaudit-dev [linux-any], libcap-dev [linux-any], libselinux-dev [linux-any], systemtap-sdt-dev [linux-any],
 mig (>= 1.3-2) [hurd-i386], hurd-dev (>= 1:0.5.git20140320~) [hurd-i386], gnumach-dev (>= 2:1.4-2~) [hurd-i386],
 kfreebsd-kernel-headers [kfreebsd-any],
 binutils (>= 2.21),
 g++-4.8 (>= 4.8.3-8), g++-4.8-multilib [amd64 armhf armel i386 kfreebsd-amd64 mips mipsel mipsn32 mipsn32el mips64 mips64el powerpc ppc64 s390x sparc sparc64 x32]
Build-Depends-Indep: perl, po-debconf (>= 1.0)
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: GNU Libc Maintainers <debian-glibc@lists.debian.org>
Uploaders: Clint Adams <clint@debian.org>, Aurelien Jarno <aurel32@debian.org>, Adam Conrad <adconrad@0c3.net>
Standards-Version: 3.9.5
Vcs-Browser: http://svn.debian.org/wsvn/pkg-glibc/glibc-package/
Vcs-Svn: svn://svn.debian.org/pkg-glibc/glibc-package/
Homepage: http://www.gnu.org/software/libc/libc.html
XS-Testsuite: autopkgtest

Package: libc-bin
Architecture: any
Section: libs
Priority: required
Essential: yes
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, hurd (>= 20070606-1+SVN) [hurd-i386]
Breaks: libc0.1 (<< 2.10), libc0.3 (<< 2.10), libc6 (<< 2.10), libc6.1 (<< 2.10)
Replaces: libc0.1, libc0.3, libc6, libc6.1
Build-Profiles: <!stage1>
Description: GNU C Library: Binaries
 This package contains utility programs related to the GNU C Library.
 .
  * catchsegv: catch segmentation faults in programs
  * getconf: query system configuration variables
  * getent: get entries from administrative databases
  * iconv, iconvconfig: convert between character encodings
  * ldd, ldconfig: print/configure shared library dependencies
  * locale, localedef: show/generate locale definitions
  * tzselect, zdump, zic: select/dump/compile time zones

Package: libc-dev-bin
Architecture: any
Section: libdevel
Priority: optional
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: manpages-dev
Replaces: libc0.1-dev, libc0.3-dev, libc6-dev, libc6.1-dev
Build-Profiles: <!stage1>
Description: GNU C Library: Development binaries
 This package contains utility programs related to the GNU C Library
 development package.

Package: glibc-doc
Architecture: all
Section: doc
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}, glibc-doc-reference (>= 2.18)
Build-Profiles: <!stage1>
Description: GNU C Library: Documentation
 Contains man pages for libpthread functions and the complete GNU C Library
 ChangeLog.  The GNU C Library Reference manual has been moved into
 glibc-doc-reference for licensing reasons.

Package: glibc-source
Architecture: all
Section: devel
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: xz-utils
Conflicts: eglibc-source
Replaces: eglibc-source
Build-Profiles: <!stage1>
Description: GNU C Library: sources
 This package contains the sources and patches which are needed to
 build glibc.

Package: locales
Architecture: all
Section: localization
Priority: standard
Depends: ${locale:Depends}, ${misc:Depends}, debconf | debconf-2.0
Conflicts: base-config, belocs-locales-bin, belocs-locales-data
Replaces: base-config, lliurex-belocs-locales-data, manpages-fr-extra (<< 20141022)
Build-Profiles: <!stage1>
Description: GNU C Library: National Language (locale) data [support]
 Machine-readable data files, shared objects and programs used by the
 C library for localization (l10n) and internationalization (i18n) support.
 .
 This package contains the libc.mo i18n files, plus tools to generate
 locale definitions from source files (included in this package). It
 allows you to customize which definitions actually get
 generated. This is a space-saver over how this package used to be,
 with all locales generated by default. This created a package that
 unpacked to an excess of 30 megs.

Package: locales-all
Architecture: any
Section: localization
Priority: extra
Multi-Arch: foreign
Depends: ${locale:Depends}, ${misc:Depends}
Breaks: locales (<< 2.13-17)
Provides: locales
Build-Profiles: <!stage1>
Description: GNU C Library: Precompiled locale data
 This package contains the precompiled locale data for all supported locales.
 A better alternative is to install the locales package and only select
 desired locales, but it can be useful on a low-memory machine because some
 locale files take a lot of memory to be compiled.

Package: nscd
Architecture: any
Section: admin
Multi-Arch: foreign
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: Name Service Cache Daemon
 A daemon which handles passwd, group and host lookups
 for running programs and caches the results for the next
 query. You should install this package only if you use
 slow services like LDAP, NIS or NIS+.

Package: multiarch-support
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
	 libc6 (>= 2.3.6-2) [!any-i386 !alpha !armhf !hurd-any !kfreebsd-any],
         libc6.1 (>= 2.3.6-2) [alpha],
         libc0.3 (>= 2.3.6-2) [!linux-any !kfreebsd-any !hurd-i386],
         libc0.1 (>= 2.3.6-2) [!linux-any !hurd-any !kfreebsd-i386],
         libc6 (>= 2.13-5) [armhf i386],
         libc0.3 (>= 2.13-5) [hurd-i386],
         libc0.1 (>= 2.13-5) [kfreebsd-i386],
Priority: required
Build-Profiles: <!stage1>
Description: Transitional package to ensure multiarch compatibility
 This is a transitional package used to ensure multiarch support is present
 in ld.so before unpacking libraries to the multiarch directories.  It can
 be removed once nothing on the system depends on it.

Package: libc6
Architecture: amd64 arm arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el powerpc powerpcspe ppc64 ppc64el sparc sparc64 s390x sh4 x32
Section: libs
Priority: required
Multi-Arch: same
Depends: ${shlibs:Depends}, ${libgcc:Depends}
Recommends: libc0.1-i686 [kfreebsd-i386], libc0.3-i686 [hurd-i386] 
Suggests: glibc-doc, debconf | debconf-2.0, locales [!hurd-i386]
Provides: ${locale-compat:Depends}, libc6-sparcv9b [sparc sparc64], libc6-i686 [i386], libc6-xen [i386], libc6-armel [armel], libc6-armhf [armhf]
Conflicts: tzdata-etch, tzdata (<< 2007k-1), prelink (<= 0.0.20090311-1), libc6-xen [i386]
Breaks: nscd (<< 2.19), lsb-core (<= 3.2-27) [amd64 ppc64 sparc64], libx11-6 (<< 1.1.4-2) [hurd-i386], libpthread-stubs0 (<< 0.3-4) [hurd-i386], hurd (<< 1:0.5.git20140203-1), libtirpc1 (<< 0.2.3)
Replaces: libc6-amd64 [amd64],
          libc6-i386 [i386],
          libc6-xen [i386],
          libc6-x32 [x32],
          libc0.1-i386 [kfreebsd-i386],
          libc6-powerpc [powerpc],
          libc6-ppc64 [ppc64],
          libc6-s390x [s390x],
          libc6-sparc64 [sparc64],
          libc6-mips64 [mips64 mips64el],
          libc6-mipsn32 [mipsn32 mipsn32el],
          libc6-mips32 [mips mipsel],
          hurd (<< 20120408-3) [hurd-i386]
Build-Profiles: <!stage1>
Description: GNU C Library: Shared libraries
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.

Package: libc6-dev
Architecture: amd64 arm arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el powerpc powerpcspe ppc64 ppc64el sparc sparc64 s390x sh4 x32
Section: libdevel
Priority: optional
Multi-Arch: same
Depends: libc6 (= ${binary:Version}), libc-dev-bin (= ${binary:Version}), ${misc:Depends}, linux-libc-dev [linux-any], kfreebsd-kernel-headers (>= 0.11) [kfreebsd-any], gnumach-dev [hurd-i386], hurd-dev (>= 20080607-3) [hurd-i386]
Replaces: hurd-dev (<< 20120408-3) [hurd-i386]
Suggests: glibc-doc, manpages-dev
Provides: libc-dev, libc6-dev [alpha hurd-i386 kfreebsd-i386 kfreebsd-amd64], libc6-dev-armel [armel], libc6-dev-armhf [armhf]
Breaks: binutils (<< 2.20.1-1), binutils-gold (<< 2.20.1-11), cmake (<< 2.8.4+dfsg.1-5), gcc-4.4 (<< 4.4.6-4), gcc-4.5 (<< 4.5.3-2), gcc-4.6 (<< 4.6.0-12), make (<< 3.81-8.1), pkg-config (<< 0.26-1), libjna-java (<< 3.2.7-4), liblouis-dev (<< 2.3.0-2), liblouisxml-dev (<< 2.4.0-2), libhwloc-dev (<< 1.2-3), check (<< 0.9.10-6.1+b1) [s390x]
Conflicts: libc6.1-dev, libc0.1-dev, libc0.3-dev,
Description: GNU C Library: Development Libraries and Header Files
 Contains the symlinks, headers, and object files needed to compile
 and link programs which use the standard C library.

Package: libc6-dbg
Architecture: amd64 arm arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el powerpc powerpcspe ppc64 ppc64el sparc sparc64 s390x sh4 x32
Section: debug
Priority: extra
Multi-Arch: same
Provides: libc-dbg
Depends: libc6 (= ${binary:Version}), ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: detached debugging symbols
 This package contains the detached debugging symbols for the GNU C
 library.

Package: libc6-pic
Architecture: amd64 arm arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el powerpc powerpcspe ppc64 ppc64el sparc sparc64 s390x sh4 x32
Section: libdevel
Priority: optional
Multi-Arch: same
Conflicts: libc-pic
Provides: libc-pic, glibc-pic
Depends: libc6 (= ${binary:Version}), ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: PIC archive library
 Contains an archive library (ar file) composed of individual shared objects.
 This is used for creating a library which is a smaller subset of the
 standard libc shared library. The reduced library is used by debian-installer
 and may be useful for custom installation media and in embedded systems.

Package: libc6-udeb
XC-Package-Type: udeb
Architecture: amd64 arm arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el powerpc powerpcspe ppc64 ppc64el sparc sparc64 s390x sh4 x32
Section: debian-installer
Priority: extra
Provides: libc6, libc-udeb, ${locale-compat:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: Shared libraries - udeb
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.
 .
 This package contains a minimal set of libraries needed for the Debian
 installer.  Do not install it on a normal system.

Package: libc6.1
Architecture: alpha
Section: libs
Priority: required
Multi-Arch: same
Depends: ${shlibs:Depends}, ${libgcc:Depends}
Recommends: libc0.1-i686 [kfreebsd-i386], libc0.3-i686 [hurd-i386] 
Suggests: glibc-doc, debconf | debconf-2.0, locales [!hurd-i386]
Provides: ${locale-compat:Depends}, libc6-sparcv9b [sparc sparc64], libc6-i686 [i386], libc6-xen [i386], libc6-armel [armel], libc6-armhf [armhf]
Conflicts: tzdata-etch, tzdata (<< 2007k-1), prelink (<= 0.0.20090311-1), libc6-xen [i386]
Breaks: nscd (<< 2.19), lsb-core (<= 3.2-27) [amd64 ppc64 sparc64], libx11-6 (<< 1.1.4-2) [hurd-i386], libpthread-stubs0 (<< 0.3-4) [hurd-i386], hurd (<< 1:0.5.git20140203-1), libtirpc1 (<< 0.2.3)
Replaces: libc6-amd64 [amd64],
          libc6-i386 [i386],
          libc6-xen [i386],
          libc6-x32 [x32],
          libc0.1-i386 [kfreebsd-i386],
          libc6-powerpc [powerpc],
          libc6-ppc64 [ppc64],
          libc6-s390x [s390x],
          libc6-sparc64 [sparc64],
          libc6-mips64 [mips64 mips64el],
          libc6-mipsn32 [mipsn32 mipsn32el],
          libc6-mips32 [mips mipsel],
          hurd (<< 20120408-3) [hurd-i386]
Build-Profiles: <!stage1>
Description: GNU C Library: Shared libraries
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.

=== debian/control ===
Source: console-setup
Section: utils
Priority: optional
Maintainer: Ubuntu Installer Team <ubuntu-installer@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders: Anton Zinoviev <zinoviev@debian.org>, Christian Perrier <bubulle@debian.org>
Build-Depends-Indep: perl, libxml-parser-perl, xkb-data (>= 1.6), xkb-data-i18n, keymapper (>= 0.5.3-7)
Build-Depends: debhelper (>= 7), po-debconf, bdfresize, liblocale-gettext-perl,
 language-pack-af,
 language-pack-an,
 language-pack-ar,
 language-pack-as,
 language-pack-ast,
 language-pack-az,
 language-pack-be,
 language-pack-bg,
 language-pack-bn,
 language-pack-bo,
 language-pack-br,
 language-pack-bs,
 language-pack-ca,
 language-pack-crh,
 language-pack-cs,
 language-pack-cy,
 language-pack-da,
 language-pack-de,
 language-pack-dz,
 language-pack-el,
 language-pack-en,
 language-pack-eo,
 language-pack-es,
 language-pack-et,
 language-pack-eu,
 language-pack-fa,
 language-pack-fi,
 language-pack-fr,
 language-pack-ga,
 language-pack-gd,
 language-pack-gl,
 language-pack-gu,
 language-pack-he,
 language-pack-hi,
 language-pack-hr,
 language-pack-hu,
 language-pack-id,
 language-pack-is,
 language-pack-it,
 language-pack-ja,
 language-pack-ka,
 language-pack-kk,
 language-pack-km,
 language-pack-kn,
 language-pack-ko,
 language-pack-ku,
 language-pack-lt,
 language-pack-lv,
 language-pack-mai,
 language-pack-mk,
 language-pack-ml,
 language-pack-mn,
 language-pack-mr,
 language-pack-ms,
 language-pack-my,
 language-pack-nb,
 language-pack-nds,
 language-pack-ne,
 language-pack-nl,
 language-pack-nn,
 language-pack-oc,
 language-pack-or,
 language-pack-pa,
 language-pack-pl,
 language-pack-pt,
 language-pack-ro,
 language-pack-ru,
 language-pack-si,
 language-pack-sk,
 language-pack-sl,
 language-pack-sq,
 language-pack-sr,
 language-pack-sv,
 language-pack-ta,
 language-pack-te,
 language-pack-tg,
 language-pack-th,
 language-pack-tr,
 language-pack-ug,
 language-pack-uk,
 language-pack-uz,
 language-pack-vi,
 language-pack-xh,
 language-pack-zh-hans,
 language-pack-zh-hant,
Standards-Version: 3.8.3
XS-Debian-Vcs-Browser: http://git.debian.org/?p=d-i/console-setup.git
XS-Debian-Vcs-Git: git://git.debian.org/d-i/console-setup.git
Vcs-Bzr: http://bazaar.launchpad.net/~ubuntu-core-dev/console-setup/ubuntu

Package: keyboard-configuration
Section: utils
Architecture: all
Depends: debconf (>= 1.5.34), ${misc:Depends}, liblocale-gettext-perl
Conflicts: console-setup (<< 1.47), console-setup-mini (<< 1.47)
Replaces: console-setup (<< 1.47), console-setup-mini (<< 1.47)
Description: system-wide keyboard preferences
 This package maintains the keyboard preferences in
 /etc/default/keyboard.  Other packages can use the information
 provided by this package in order to configure the keyboard on the
 console or in X Window.

Package: console-setup
Section: utils
Architecture: all
Depends: debconf (>= 1.5.34), xkb-data (>= 0.9), keyboard-configuration, initramfs-tools (>= 0.85eubuntu12), kbd (>= 1.15-1ubuntu3), ${misc:Depends}
Suggests: lsb-base (>= 3.0-6), locales
Conflicts: lsb-core (<< 2.0-6), lsb (<< 2.0-6), lsb-base (<< 3.0-6), console-terminus
Provides: console-terminus
Replaces: console-terminus
Description: console font and keymap setup program
 This package provides the Linux console with the same
 keyboard configuration scheme as the X Window System. As a result,
 there is no need to duplicate or change the keyboard files just to
 make simple customizations such as the use of dead keys, the key
 functioning as AltGr or Compose key, the key(s) to switch between
 Latin and non-Latin mode, etc.
 .
 The package also contains console fonts supporting many of the
 world's languages.  It provides an unified set of font faces - the
 classic VGA, the simplistic Fixed, and the cleaned Terminus,
 TerminusBold and TerminusBoldVGA.

Package: console-setup-mini
Section: utils
Priority: extra
Architecture: all
Recommends: kbd | console-tools
Depends: debconf (>= 0.5) | debconf-2.0, keyboard-configuration, ${misc:Depends}
Suggests: lsb-base (>= 3.0-6)
Conflicts: console-setup, console-terminus, lsb-core (<< 2.0-6), lsb (<< 2.0-6), lsb-base (<< 3.0-6)
Description: console font and keymap setup program - reduced version
 This package provides the Linux console with the same
 keyboard configuration scheme as the X Window System. As a result,
 there is no need to duplicate or change the keyboard files just to
 make simple customizations such as the use of dead keys, the key
 functioning as AltGr or Compose key, the key(s) to switch between
 Latin and non-Latin mode, etc.
 .
 The package also contains console fonts supporting many of the
 world's languages.  It provides a unified set of font faces - the
 classic VGA, the simplistic Fixed, and the clean Terminus,
 TerminusBold, and TerminusBoldVGA.
 .
 This package can be useful for
 handhelds or other devices with small storage space.
 .
 The package supports only UTF-8. Legacy 8-bit encodings are not
 supported.

Package: bdf2psf
Architecture: all
Section: utils
Priority: optional
Depends: perl, ${misc:Depends}
Description: font converter to generate console fonts from BDF source fonts
 This package provides a command-line converter that can be used in
 scripts to build console fonts from BDF sources automatically. The
 converter comes with a collection of font encodings that cover many
 of the world's languages. The output font can use a different
 character encoding from the input. When the source font does not
 define a glyph for a particular symbol in the encoding table, that
 glyph position in the console font is not wasted but used for another
 symbol.
 .
 When deciding about the position in the font for a particular glyph,
 the converter takes into account that in text video modes the video
 adapter copies the eighth column of the glyph matrix of symbols
 positioned in the pseudographic area to the ninth column. In order to
 create fonts for text video modes, the width of the glyph matrix of
 the source BDF font should be seven, eight, or nine pixels; otherwise the
 converter creates fonts suitable for framebuffer only.

Package: console-setup-udeb
Section: debian-installer
Priority: extra
Depends: console-setup-ekmap, archdetect, cdebconf-udeb, kbd-udeb, cdebconf-newt-detect-keys, ${misc:Depends}
Provides: keyboard-setup
Architecture: all
Description: Configure the keyboard
 This is an experimental replacement of kbd-chooser.
XC-Package-Type: udeb
XB-Installer-Menu-Item: 1200

Package: console-setup-amiga-ekmap
Provides: console-setup-ekmap
Section: debian-installer
Priority: extra
Depends: ${misc:Depends}
Architecture: all
Description: encoded keyboard layouts for Amiga keyboards
XC-Package-Type: udeb

Package: console-setup-ataritt-ekmap
Provides: console-setup-ekmap
Section: debian-installer
Priority: extra
Depends: ${misc:Depends}
Architecture: all
Description: encoded keyboard layouts for Atari TT keyboards
XC-Package-Type: udeb

Package: console-setup-macintoshold-ekmap
Provides: console-setup-ekmap
Section: debian-installer
Priority: extra
Depends: ${misc:Depends}
Architecture: all
Description: encoded keyboard layouts for old-style Macintosh keyboards
XC-Package-Type: udeb

Package: console-setup-pc-ekmap
Provides: console-setup-ekmap
Section: debian-installer
Priority: extra
Depends: ${misc:Depends}
Architecture: all
Description: encoded keyboard layouts for PC keyboards
XC-Package-Type: udeb

Package: console-setup-sun4-ekmap
Provides: console-setup-ekmap
Section: debian-installer
Priority: extra
Depends: ${misc:Depends}
Architecture: all
Description: encoded keyboard layouts for Sun4 keyboards
XC-Package-Type: udeb

Package: console-setup-sun5-ekmap
Provides: console-setup-ekmap
Section: debian-installer
Priority: extra
Depends: ${misc:Depends}
Architecture: all
Description: encoded keyboard layouts for Sun5 keyboards
XC-Package-Type: udeb

Package: console-setup-fonts-udeb
Section: debian-installer
Priority: extra
Depends: ${misc:Depends}
Architecture: all
Description: console fonts for Debian Installer
XC-Package-Type: udeb

=== rules ===
#! /usr/bin/make -f

#export DH_VERBOSE=1
#export DEB_BUILD_OPTIONS="nostrip"

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

VERSION = $(shell dpkg-parsechangelog | sed -n -e '/^Version:/s/.*: //p')

ifneq (,$(findstring stage1,$(DEB_BUILD_PROFILES)))
BOOTSTRAP_DH_FLAGS := -Ngir1.2-gudev-1.0 -Nlibgudev-1.0-0 -Nlibgudev-1.0-dev
endif

CONFFLAGS = \
	--with-rootprefix= \
	--with-rootlibdir=/lib/$(DEB_HOST_MULTIARCH) \
	--with-zshcompletiondir=/usr/share/zsh/vendor-completions \
	--with-sysvinit-path=/etc/init.d \
	--with-sysvrcnd-path=/etc \
	--with-firmware-path=/lib/firmware \
	--with-debug-shell=/bin/bash \
	--with-telinit=/lib/sysvinit/telinit \
	--disable-coredump \
	--disable-efi \
	--disable-myhostname \
	--disable-vconsole \
	--disable-microhttpd \
	--disable-sysusers \
	--disable-silent-rules \
	--with-ntp-servers="0.debian.pool.ntp.org 1.debian.pool.ntp.org 2.debian.pool.ntp.org 3.debian.pool.ntp.org"  \
	--with-system-uid-max=999 \
	--with-system-gid-max=999

ifeq (,$(findstring stage1,$(DEB_BUILD_PROFILES)))
CONFFLAGS += --enable-libcryptsetup
endif

CONFFLAGS_deb = \
	--enable-selinux \
	--enable-introspection \
	--enable-gtk-doc \
	--enable-compat-libs \
	PYTHON=python3 \
	$(NULL)

CONFFLAGS_udeb = \
	--disable-libcryptsetup \
	--disable-pam \
	--disable-audit \
	--disable-selinux \
	--disable-smack \
	--disable-ima \
	--disable-introspection \
	--disable-gtk-doc \
	--disable-binfmt \
	--disable-bootchart \
	--disable-quotacheck \
	--disable-tmpfiles \
	--disable-randomseed \
	--disable-backlight \
	--disable-logind \
	--disable-machined \
	--disable-hostnamed \
	--disable-timedated \
	--disable-networkd \
	--disable-timesyncd \
	--disable-localed \
	--disable-resolved \
	--disable-polkit \
	--disable-acl \
	--disable-gcrypt \
	--disable-gudev \
	--disable-rfkill \
	--disable-multi-seat-x \
	--disable-manpages \
	--without-python

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build-deb \
		-- $(CONFFLAGS) $(CONFFLAGS_deb)
	dh_auto_configure --builddirectory=build-udeb \
		-- $(CONFFLAGS) $(CONFFLAGS_udeb)

override_dh_auto_build:
	dh_auto_build --builddirectory=build-deb
	dh_auto_build --builddirectory=build-udeb

override_dh_auto_install:
	dh_auto_install --builddirectory=build-deb \
		--destdir=debian/install/deb
	dh_auto_install --builddirectory=build-udeb \
		--destdir=debian/install/udeb

override_dh_auto_clean:
	dh_auto_clean --builddirectory=build-deb
	dh_auto_clean --builddirectory=build-udeb
	rm -rf debian/install/
	# remove pre-generated man pages so they are rebuilt
	rm -f man/*.[13578]
	# remove pre-generated rules and unit files so they are rebuilt
	rm -f rules/99-systemd.rules \
		units/emergency.service \
		units/systemd-udevd.service \
		units/systemd-udev-settle.service \
		units/systemd-udev-trigger.service
	# remove Python byte code files
	rm -f *.pyc

override_dh_install:
	# remove unnecessary / unused files
	rm -f debian/install/*/usr/share/doc/systemd/LICENSE.*
	rm -f debian/install/*/var/log/README
	rm -f debian/install/*/etc/init.d/README
	rm -f debian/install/*/usr/share/man/man8/kernel-install.8
	rm -f debian/install/*/usr/bin/kernel-install
	rm -f debian/install/*/usr/share/zsh/vendor-completions/_kernel-install
	rm -f debian/install/*/usr/share/bash-completion/completions/kernel-install
	rm -rf debian/install/*/usr/lib/kernel/install.d
	rm -rf debian/install/*/etc/rpm/
	rm -rf debian/install/*/usr/lib/rpm/
	rm -rf debian/install/*/etc/kernel/
	rm -f debian/install/*/usr/lib/sysctl.d/50-default.conf
	find debian/install/ -name '*.la' -delete
	# remove files related to factory-reset feature
	find debian/install/ \( -name 'systemd-update-done*' -o \
		-name systemd-journal-catalog-update.service -o \
		-name systemd-udev-hwdb-update.service -o \
		-name ldconfig.service -o \
		-name etc.conf \) -delete
	rm -rf debian/install/*/usr/share/factory/
	# don't ship systemd-firstboot for now; we rather want debconf, and
	# this needs to be adjusted to Debian config files
	rm -f debian/install/*/usr/share/man/man*/*firstboot*
	rm -f debian/install/*/lib/systemd/system/*firstboot*
	rm -f debian/install/*/lib/systemd/system/*.wants/*firstboot*
	rm -f debian/install/*/bin/*firstboot*
	# remove .so for deprecated compatibility libraries
	rm -f debian/install/*/usr/lib/*/libsystemd-daemon.so
	rm -f debian/install/*/usr/lib/*/libsystemd-login.so
	rm -f debian/install/*/usr/lib/*/libsystemd-id128.so
	rm -f debian/install/*/usr/lib/*/libsystemd-journal.so
	# remove symlinks enabling default-on services
	rm -rf debian/install/*/etc/systemd/system/*.target.wants/
	dh_install -pudev-udeb -plibudev1-udeb --sourcedir=debian/install/udeb
	# we disable machined for now, so don't ship nss-mymachines either
	rm -f debian/install/*/usr/lib/*/libnss_mymachines*
	# still needs to mature a bit, and packaging
	rm -f debian/install/*/usr/lib/*/libnss_resolve*
	dh_install $(BOOTSTRAP_DH_FLAGS) -Nudev-udeb -Nlibudev1-udeb --sourcedir=debian/install/deb --fail-missing
	# install some files manually, --sourcedir makes that necessary
	# udev-udeb
	install -D --mode=755 debian/extra/udev.startup \
		debian/udev-udeb/lib/debian-installer/start-udev
	install -D --mode=755 debian/extra/udev.base-installer \
		debian/udev-udeb/usr/lib/base-installer.d/05udev
	mkdir -p debian/udev-udeb/lib/udev/rules.d/
	install -D --mode=644 \
		debian/extra/rules/50-firmware.rules \
		debian/extra/rules/73-idrac.rules \
		debian/extra/rules/75-persistent-net-generator.rules \
		debian/udev-udeb/lib/udev/rules.d/
	mkdir -p debian/udev-udeb/lib/udev
	install -D --mode=644 \
		debian/extra/hotplug.functions \
		debian/extra/rule_generator.functions \
		debian/udev-udeb/lib/udev/
	install -D --mode=755 \
		debian/extra/write_net_rules \
		debian/udev-udeb/lib/udev/
	# udev: initramfs-tools support
	install -D --mode=755 debian/extra/initramfs.hook \
		debian/udev/usr/share/initramfs-tools/hooks/udev
	install -D --mode=755 debian/extra/initramfs.top \
		debian/udev/usr/share/initramfs-tools/scripts/init-top/udev
	install -D --mode=755 debian/extra/initramfs.bottom \
		debian/udev/usr/share/initramfs-tools/scripts/init-bottom/udev
	# udev: debian specific rules and helpers
	install -D --mode=644 debian/extra/rules/* \
		debian/udev/lib/udev/rules.d/
	install -D --mode=644 debian/extra/fbdev-blacklist.conf \
		debian/udev/etc/modprobe.d/fbdev-blacklist.conf
	install -D --mode=644 \
		debian/extra/hotplug.functions \
		debian/extra/rule_generator.functions \
		debian/udev/lib/udev/
	install -D --mode=755 \
		debian/extra/udev-finish \
		debian/extra/write_net_rules \
		debian/udev/lib/udev/
	# systemd
	cp -a debian/pam-configs debian/libpam-systemd/usr/share/
	install -D --mode=644 debian/init-functions.d/40-systemd \
		debian/systemd/lib/lsb/init-functions.d/40-systemd
	install --mode=644 debian/tmpfiles.d/debian.conf \
		debian/systemd/usr/lib/tmpfiles.d/
	install --mode=644 debian/debian-fixup.service debian/ifup@.service \
		debian/systemd/lib/systemd/system/
	install --mode=644 debian/extra/udev-finish.service \
		debian/udev/lib/systemd/system/
	ln -s ../udev-finish.service debian/udev/lib/systemd/system/sysinit.target.wants/
	install --mode=755 debian/debian-fixup \
		debian/systemd/lib/systemd/
	# Make sure the runlevel services are known by systemd so their targets
	# get launches. See https://bugzilla.redhat.com/show_bug.cgi?id=1002806
	for t in poweroff rescue multi-user graphical reboot; do \
		mkdir -p debian/systemd/lib/systemd/system/$${t}.target.wants;\
		ln -s ../systemd-update-utmp-runlevel.service \
			debian/systemd/lib/systemd/system/$${t}.target.wants ;\
	done
	# man files for example code in /usr/share/doc
	mkdir -p debian/systemd/usr/share/man/man3/
	install --mode=755 debian/systemd-logind-launch \
		debian/systemd/lib/systemd/
	# remove duplicates
	# files shipped by systemd-sysv / sysvinit
	rm debian/systemd/usr/share/man/man1/init.1
	rm debian/systemd/usr/share/man/man8/halt.8

=== tests/control ===
Tests: timedated hostnamed localed-locale localed-x11-keymap logind
Depends: systemd, libpam-systemd, acl
Restrictions: needs-root isolation-machine

Tests: build-login
Depends: libsystemd-login-dev, build-essential, pkg-config

Tests: python3
Depends: python3-systemd

Tests: boot-and-services
Depends: lightdm, cron, network-manager, busybox-static, apparmor
Restrictions: needs-root, isolation-machine, needs-recommends, breaks-testbed
